import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Attackable here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public abstract class Attackable  extends Actor
{
    private int health;

    public Attackable(int health){
        this.health = health;
    }
    
    protected void attack(int attackStrength){
        Field world = (Field)getWorld();
        if(world != null){
            int defenseStrength = Greenfoot.getRandomNumber(100);
            //System.out.println("Defending: "+defenseStrength);
            if(defenseStrength < this.getDefense()){
                defenseStrength = (defenseStrength*100) / this.getDefense();
                //System.out.println("getDefense() = "+getDefense());
                //System.out.println("defenseStrength = "+defenseStrength);
                attackStrength -= defenseStrength;
            }
            Attack attack = new Attack(this);
            world.addObject(attack, getX(), getY());
            //System.out.println("attackStrength = "+attackStrength);
            health -= attackStrength;
            //System.out.println("health = "+health);
            if(health <= 0){
                ///System.out.println("Died!");
                killed(attack);
                attack.setFatalAttack(true);
                if(this instanceof Bug) world.removeFromCount((Bug)this);
                world.removeObject(this);
            }
        }
    }
    
    protected final boolean doAct(){
        return ((Field)getWorld()).doAct();
    }
    
    protected final int getHealth(){
        return health;
    }
    
    protected abstract Nest getNest();
    protected abstract int getDefense();
    protected void killed(Attack attack){}
}
