import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)
import java.util.List;

/**
 * Write a description of class Nest here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Nest extends Attackable
{
    public static final int METHOD_RANDOM = 0;
    public static final int METHOD_SOLDIER = 1;
    public static final int METHOD_SCOUT = 2;
    public static final int METHOD_SCOUTS_FIRST = 3;
    public static final int METHOD_SOLDIERS_FIRST = 4;
    public static final int METHOD_SLIDER = 5;
    public static final int METHOD_INTELLIGENT = 6;
    public static final int METHOD_INTEL_SCOUTS_FIRST = 7;
    
    private static final int MAX_HEALTH = 6000;
    private int step = 0, minorStep = -1;
    private boolean bugsReachedNest;    //For intel methods
    private Scout scoutAtNest;          //For intel methods
    private java.awt.Color colour;
    private int releaseMethod = METHOD_RANDOM;
    private Slider slider;
    private String scoutImage, soldierImage, defenderImage;
    
    public Nest(java.awt.Color colour){
        super(MAX_HEALTH);
        this.colour = colour;
    }
    
    public static Nest createRedNest(){
        Nest nest = new Nest(java.awt.Color.RED);
        nest.scoutImage = "Bug_red_scout.png";
        nest.soldierImage = "Bug_red_soldier.png";
        nest.defenderImage = "Bug_red_defender.png";
        //nest.setImage("anthill_red.gif");
        return nest;
    }
    
    public static Nest createBlueNest(){
        Nest nest = new Nest(java.awt.Color.BLUE);
        nest.scoutImage = "Bug_blue_scout.png";
        nest.soldierImage = "Bug_blue_soldier.png";
        nest.defenderImage = "Bug_blue_defender.png";
        //nest.setImage("anthill_blue.png");
        return nest;
    }
    
    protected void addedToWorld(World world){
    }
    
    /**
     * Act - do whatever the Nest wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if(doAct()){
            if(step-- <= 0){
                Bug bug;
                minorStep++;
                if(releaseMethod == METHOD_SOLDIER){
                    bug = new Soldier(this);
                    bug.setImage(soldierImage);
                    int rotate = getRotation();
                    rotate += Greenfoot.getRandomNumber(91)-45;
                    bug.setRotation(rotate);
                }else if(releaseMethod == METHOD_SCOUT){
                    bug = new Scout(this);
                    bug.setImage(scoutImage);
                    bug.setRotation(Greenfoot.getRandomNumber(360));
                }else if(releaseMethod == METHOD_SCOUTS_FIRST){
                    if(minorStep >= 75){
                        minorStep = 0;
                    }
                    if(minorStep < 10){
                        bug = new Scout(this);
                        bug.setImage(scoutImage);
                        bug.setRotation(Greenfoot.getRandomNumber(360));
                    }else{
                        bug = new Soldier(this);
                        bug.setImage(soldierImage);
                        int rotate = getRotation();
                        rotate += Greenfoot.getRandomNumber(91)-45;
                        bug.setRotation(rotate);
                    }
                }else if(releaseMethod == METHOD_SOLDIERS_FIRST){
                    if(minorStep >= 70){
                        minorStep = 0;
                    }
                    if(minorStep < 60){
                        bug = new Soldier(this);
                        bug.setImage(soldierImage);
                        int rotate = getRotation();
                        rotate += Greenfoot.getRandomNumber(91)-45;
                        bug.setRotation(rotate);
                    }else{
                        bug = new Scout(this);
                        bug.setImage(scoutImage);
                        bug.setRotation(Greenfoot.getRandomNumber(360));
                    }
                }else if(releaseMethod == METHOD_INTELLIGENT){
                    Nest otherNest = null;
                    List nests = getWorld().getObjects(Nest.class);
                    for(Object obj: nests){
                        if(obj != this){
                            otherNest = (Nest)obj;
                            break;
                        }
                    }
                    if(bugsReachedNest == false){
                        List bugs = getWorld().getObjects(Soldier.class);
                        for(Object obj: bugs){
                            Bug soldier = (Bug)obj;
                            //NOTE: the less-than-or-equal-to is dependant on this nest being on the right
                            if(soldier.getNest() == this && soldier.getX() <= otherNest.getX()){
                                bugsReachedNest = true;
                                break;
                            }
                        }
                    }
                    if(bugsReachedNest && (scoutAtNest == null || scoutAtNest.getWorld() == null)){
                        scoutAtNest = null;
                        if(bugsReachedNest){
                            List scouts = getWorld().getObjects(Scout.class);
                            for(Object obj: scouts){
                                Scout scout = (Scout)obj;
                                if(scout.getNest() == this && scout.getNestFound() == otherNest){
                                    scoutAtNest = scout;
                                    break;
                                }
                            }
                        }
                    }
                    boolean scoutsReachedNest = scoutAtNest != null;
                    if(
                        (bugsReachedNest && !scoutsReachedNest && (minorStep %= 4) == 0)
                            ||
                        (!bugsReachedNest && Greenfoot.getRandomNumber(100) >= 90)
                    ){
                        bug = makeScout();
                    }else{
                        bug = makeSoldier();
                    }
                    
                    
                }else if(releaseMethod == METHOD_INTEL_SCOUTS_FIRST){
                    if(!bugsReachedNest && minorStep <= 10){
                        if(Greenfoot.getRandomNumber(100) < 25){
                            bug = makeScout();
                        }else{
                            bug = makeSoldier();
                        }
                    }else{
                        Nest otherNest = null;
                        List nests = getWorld().getObjects(Nest.class);
                        for(Object obj: nests){
                            if(obj != this){
                                otherNest = (Nest)obj;
                                break;
                            }
                        }
                        if(bugsReachedNest == false){
                            List bugs = getWorld().getObjects(Soldier.class);
                            for(Object obj: bugs){
                                Bug soldier = (Bug)obj;
                                //NOTE: the less-than-or-equal-to is dependant on this nest being on the right
                                if(soldier.getNest() == this && soldier.getX() <= otherNest.getX()){
                                    bugsReachedNest = true;
                                    break;
                                }
                            }
                        }
                        if(bugsReachedNest && (scoutAtNest == null || scoutAtNest.getWorld() == null)){
                            scoutAtNest = null;
                            if(bugsReachedNest){
                                List scouts = getWorld().getObjects(Scout.class);
                                for(Object obj: scouts){
                                    Scout scout = (Scout)obj;
                                    if(scout.getNest() == this && scout.getNestFound() == otherNest){
                                        scoutAtNest = scout;
                                        break;
                                    }
                                }
                            }
                        }
                        boolean scoutsReachedNest = scoutAtNest != null;
                        if(
                            (bugsReachedNest && !scoutsReachedNest && (minorStep %= 4) == 0)
                                ||
                            (!bugsReachedNest && Greenfoot.getRandomNumber(100) >= 90)
                        ){
                            bug = makeScout();
                        }else{
                            bug = makeSoldier();
                        }
                    }
                    
                //Default method
                }else{
                    int chanceOfSoldier;
                    if(releaseMethod == METHOD_SLIDER){
                        if(slider != null){
                            chanceOfSoldier = slider.getValue();
                        }else{
                            System.err.println("Cannot find slider");
                            chanceOfSoldier = 95;
                        }
                    }else{
                        chanceOfSoldier = 95;
                    }
                    if(Greenfoot.getRandomNumber(100)<chanceOfSoldier){
                        bug = makeSoldier();
                    }else{
                        bug = makeScout();
                    } 
                }
                
                getWorld().addObject(bug, getX(), getY());
                step = Greenfoot.getRandomNumber(20);
            }
        }
    }   
    
    public java.awt.Color getColour(){
        return colour;
    }
    
    public void setReleaseMethod(int method){
        releaseMethod = method;
    }
    
    public void setSliderReleaseMethod(Slider slider){
        this.slider = slider;
        releaseMethod = METHOD_SLIDER;
    }
    
    protected void attack(int attackStrength){
        super.attack(attackStrength);
        getImage().setTransparency(Math.min((255*Math.max(0,getHealth()))/MAX_HEALTH, 255));
        /*health -= attackStrength;
        Attack attack = new Attack(this);
        getWorld().addObject(attack, getX(), getY());
        getImage().setTransparency((255*Math.max(0,health))/MAX_HEALTH);
        System.out.println("health = "+health);
        if(health <= 0){
            attack.setFatalAttack(true);
            System.out.println("Died!");
            getWorld().removeObject(this);
                Greenfoot.stop();
        }*/
    }
    
    protected void killed(Attack attack){
        ((Field)getWorld()).nestDestroyed(this);
    }
    
    protected int getDefense(){
        return 0;
    }
    
    protected Nest getNest(){
        return this;
    }
    
    private Soldier makeSoldier(){
        Soldier bug = new Soldier(this);
        bug.setImage(soldierImage);
        int rotate = getRotation();
        rotate += Greenfoot.getRandomNumber(91)-45;
        bug.setRotation(rotate);
        return bug;
    }
    
    private Scout makeScout(){
        Scout bug = new Scout(this);
        bug.setImage(scoutImage);
        bug.setRotation(Greenfoot.getRandomNumber(360));
        return bug;
    }
}
