import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)
import java.util.List;
import java.util.HashMap;

/**
 * Write a description of class Shout here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Shout extends Actor
{
    private Bug bug;
    private int strength;
    private int totalRadius;
    private int radius;
    private boolean finished = false;
    private int increment = 2;
    private static HashMap<java.awt.Color, HashMap<Integer, HashMap<Integer, GreenfootImage>>> images = new HashMap<java.awt.Color, HashMap<Integer, HashMap<Integer, GreenfootImage>>>();

    public Shout(Bug bug, int strength){
        this.bug = bug;
        this.strength = strength;
        this.totalRadius = (int)(strength*1.5);
        this.radius = bug.getImage().getWidth()/2;
        radius -= radius % increment;
        if(!images.containsKey(bug.getNest().getColour())){
            images.put(bug.getNest().getColour(), new HashMap<Integer, HashMap<Integer, GreenfootImage>>());
            System.out.println("Creating colour map: "+bug.getNest().getColour());
        }
        if(!images.get(bug.getNest().getColour()).containsKey(strength)) createImages(strength);
        setImage(new GreenfootImage(1,1));
    }
    
    /*protected static Shout createOffworldShout(Bug bug, int strength){
        Shout shout = new Shout(bug, strength){
            protected void addedToWorld(World world){
                //Do nothing
            }
        };
        return shout;
    }
    
    protected void addedToWorld(World world){
        if(getX() + totalRadius > getWorld().getWidth()){
            getWorld().addObject(Shout.createOffworldShout(bug, strength), getX()-getWorld().getWidth(), getY());
        }
        if(getX() - totalRadius < 0){
            getWorld().addObject(Shout.createOffworldShout(bug, strength), getX()+getWorld().getWidth(), getY());
        }
        if(getY() + totalRadius > getWorld().getHeight()){
            getWorld().addObject(Shout.createOffworldShout(bug, strength), getX(), getY()-getWorld().getHeight());
        }
        if(getY() - totalRadius < 0){
            getWorld().addObject(Shout.createOffworldShout(bug, strength), getX(), getY()+getWorld().getHeight());
        }
    }*/
    
    /**
     * Act - do whatever the Shout wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        if(((Field)getWorld()).doAct()){
            radius+=increment;
            if(radius > totalRadius){
                finished = true;
                getWorld().removeObject(this);
            }else{
                GreenfootImage image = images.get(bug.getNest().getColour()).get(strength).get(radius);
                setImage(image);
                List bugs = getIntersectingObjects(Bug.class);
                for(Object obj: bugs){
                    Bug bugFound = (Bug)obj;
                    int dx = getX() - bugFound.getX();
                    int dy = getY() - bugFound.getY();
                    double distance = Math.sqrt(dx*dx + dy*dy);
                    long iDistance = Math.round(distance);
                    if(iDistance <= radius && iDistance >= radius - increment){
                        //getWorld().removeObject(bugFound);
                        bugFound.hearShout(this);
                    }
                }
            }
        }
    }  
    
    public Bug getBug(){
        return bug;
    }
    
    public boolean hasFinished(){
        return finished;
    }
    
    private void createImages(int strength){
        System.out.println("Creating images for "+bug.getNest().getColour()+" for strength "+strength);
        HashMap<Integer, GreenfootImage> hashmap = new HashMap<Integer, GreenfootImage>();
        for(int radius = increment; radius <= totalRadius; radius += increment){
            GreenfootImage image = new GreenfootImage(radius*2, radius*2);
            image.setColor(bug.getNest().getColour());
            image.setTransparency((int)(255*(1-((double)radius/totalRadius))));
            image.drawOval(0, 0, radius*2-1, radius*2-1);
            hashmap.put(radius, image);
        }
        images.get(bug.getNest().getColour()).put(strength, hashmap);
    }
}
